Tool: create_database_connection
Creates a new Database Connection (DatabaseConnection / DBC) resource in a Google Cloud project and location.
A Database Connection (DatabaseConnection / DBC) represents secure connectivity details (credentials, network routing, and connection strings) used to connect to an Oracle Database (such as Autonomous Database, Exadata VM Cluster, or DB System) and execute queries via database_connection_executesql.
Requirements & Prerequisites:
- Service Account Permissions: The Oracle Database service's Per-Product Per-Project Service Account (P4SA, e.g.
service-<PROJECT_NUMBER>@gcp-sa-oracledatabase.iam.gserviceaccount.com) must have theSecret Manager Secret Accessorrole (roles/secretmanager.secretAccessor) on the password secret and optional wallet secret. - Network Connectivity: An ODB Network (
odb_network) inAVAILABLEstate is required for private network connectivity to the database.
Parameters:
parent(string, required): The parent resource name. Format:projects/{project}/locations/{location}database_connection_id(string, required): The unique ID for the DatabaseConnection (e.g.,my-db-conn).database_connection(object, required):username(string, required): The database username to authenticate with (e.g.SYSTEM,ADMIN, or custom app user).password_secret_version(string, required): Secret Manager resource name containing the database user password. Format:projects/{project}/secrets/{secret_id}/versions/{version_id}connection_string(string, required): Oracle Easy Connect or TNS descriptor (e.g.hostname.domain.com:1521/SERVICE_NAME).display_name(string, optional): A user-friendly display name for the connection.wallet_secret_version(string, optional): Secret Manager resource name containing the base64-encoded Oracle Wallet ZIP file. Required for mTLS / TLS connections (e.g. Autonomous Database). Format:projects/{project}/secrets/{secret_id}/versions/{version_id}odb_network(string, optional): The resource name of the ODB Network for private routing. Format:projects/{project}/locations/{location}/odbNetworks/{odb_network}
The following code sample shows how to use curl to call the create_database_connection MCP tool.
| Curl Request |
|---|
curl --location 'https://oracledatabase.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "create_database_connection", "arguments": { // Provide these details according to the MCP tool specification. } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request message for CreateDatabaseConnection.
CreateDatabaseConnectionRequest
| JSON representation |
|---|
{
"parent": string,
"databaseConnection": {
object ( |
| Fields | |
|---|---|
parent |
Required. The resource name of the project to create the DatabaseConnection in. Format: |
databaseConnection |
Required. The DatabaseConnection to create. |
databaseConnectionId |
Required. The ID to use for the DatabaseConnection that is being created. |
DatabaseConnection
| JSON representation |
|---|
{ "name": string, "displayName": string, "username": string, "passwordSecretVersion": string, "connectionString": string, // Union field |
| Fields | |
|---|---|
name |
Identifier. The resource name of the DatabaseConnection. Format: projects/{project}/locations/{location}/databaseConnections/{database_connection} |
displayName |
Optional. User-friendly display name for the connection. |
username |
Optional. The default database username to use for connections. |
passwordSecretVersion |
Optional. The resource name of the GCP Secret Manager secret version containing the password for the specified username. Format: projects/{project}/secrets/{secret_id}/versions/{version_id} The service's Per-Product Per-Project Service Account (P4SA) must have the 'secretmanager.secretAccessor' permission on this secret. |
connectionString |
Required. Oracle Easy Connect or TNS connection string. Example: "your-db-host.example.com:1521/YOUR_SERVICE_NAME" |
Union field wallet_source. How the Oracle Wallet is supplied for secure TLS/mTLS connections. wallet_source can be only one of the following: |
|
walletSecretVersion |
Optional. Optional: The resource name of the GCP Secret Manager secret version containing base64 encoded content of the Oracle Wallet ZIP file required for mTLS/TLS connections. Format: projects/{project}/secrets/{secret_id}/versions/{version_id} The service's Per-Product Per-Project Service Account (P4SA) must have the 'secretmanager.secretAccessor' permission on this secret. |
Union field network_configuration. Network configuration for reaching the database. network_configuration can be only one of the following: |
|
odbNetwork |
Optional. For Oracle Database@Google cloud resources. Format: projects/{project}/locations/{location}/odbNetworks/{odbNetwork} |
Output Schema
This resource represents a long-running operation that is the result of a network API call.
Operation
| JSON representation |
|---|
{ "name": string, "metadata": { "@type": string, field1: ..., ... }, "done": boolean, // Union field |
| Fields | |
|---|---|
name |
The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the |
metadata |
Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any. An object containing fields of an arbitrary type. An additional field |
done |
If the value is |
Union field result. The operation result, which can be either an error or a valid response. If done == false, neither error nor response is set. If done == true, exactly one of error or response can be set. Some services might not provide the result. result can be only one of the following: |
|
error |
The error result of the operation in case of failure or cancellation. |
response |
The normal, successful response of the operation. If the original method returns no data on success, such as An object containing fields of an arbitrary type. An additional field |
Any
| JSON representation |
|---|
{ "typeUrl": string, "value": string } |
| Fields | |
|---|---|
typeUrl |
Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name. Example: type.googleapis.com/google.protobuf.StringValue This string must contain at least one The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): In the original design of |
value |
Holds a Protobuf serialization of the type described by type_url. A base64-encoded string. |
Status
| JSON representation |
|---|
{ "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } |
| Fields | |
|---|---|
code |
The status code, which should be an enum value of |
message |
A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the |
details[] |
A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field |
Tool Annotations
Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.
Along with the title string, the following boolean hints are defined as follows:
readOnlyHint: If true, the tool doesn't modify its environment. Default: false.destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.
Destructive Hint: ❌ | Idempotent Hint: ❌ | Read Only Hint: ❌ | Open World Hint: ❌